#include "mbed.h"

AnalogIn adc(A0); // Objet (ADC) utilisé pour effectuer la démodulation
Timer timer;

bool wait_zero(void); //Cette fonction est nécessaire pour commencer la démodulation, elle permet de différencier 1 zéro d'un niveau logique bas lors de la modulation d'un 1
char decale_mot(char mot); //Cette fonction effectue une rotation des bits d'un caractère: utile pour la vérification du mot reçu
char get_word(void); // Permet d'obtenir le mot démodulé; utilise la fonction: get_bit()
char get_bit(void); //Permet de démoduler un bit du mot émis

#define delay_bit 119
#define DELAY_ZERO 10
#define SEUIL_MOYEN 0.56 

int main() {
    printf("Debut\n");
    char mot;
    int i;
    printf("Attente presence tension.\n");
    while(adc.read() > SEUIL_MOYEN); //On attend un zéro
    while (adc.read() < SEUIL_MOYEN); //On attend la fin du zéro
    // Démodulation 
    mot=get_word(); // Récupération du bit démodulé
    /* Vérification du mot reçu en utilisant le décalage binaire */
    for (i=0; i<7; i++){
        printf("%x\n", mot);
        mot=decale_mot(mot);
    }
    printf("%x\n", mot); 
    printf("Fin\n");
    while(1);
    
}


bool wait_zero(void){
    int valeur;
    valeur=0;
    while (adc.read() < DELAY_ZERO){
        valeur++;
        wait_us(5);
    }
    return (valeur < SEUIL_MOYEN)?true:false;
}

char decale_mot(char mot){ //Cette fonction effectue un décalage du mot de 1 cran vers la gauche
    mot=((mot&0x7F)<<1)|((mot&0x80)>>7); 
    return mot;
}  

char get_word(void){
    int i,time[2];
    char word; //Mots acquis
    word=0x00;
    timer.reset();
    timer.start();
    time[0]=timer.read_us();
    for(i=7;i>=0;i--){
        word |= get_bit()<<i;
    }
    time[1]=timer.read_us();
    printf("La difference des deux est: %d %d\n", time[1],time[0]);
    return word;
}

char get_bit(void){
    float moyenne, delai;
    char retour; //Valeur retournée
    moyenne = 0; //Variable pour contenir la valeur moyenne d'un bit de la trame
    delai=0; //Variable permettant de vérifier une variable;
    while(delai < delay_bit){
        moyenne += adc.read();
        wait_us(5);
        delai += 5;
    }
    moyenne /= 24;
    retour=(moyenne > SEUIL_MOYEN)?0x01:0x00;
    return retour;
}


